C for ODF3_1 10/04/2012

      SUBROUTINE ESRMOD(key,par,ugol)
c  Simulation of spectrum   
          IMPLICIT DOUBLE PRECISION (A-H),DOUBLE PRECISION (O-Z)
C
       include 'NumParam.inc'
       include 'DIMpar.inc'

       dimension specMod(NUMPOINT,2)
       dimension G(3),DH(MAXNUCL,3)
       dimension u(3,3),FiTePsi(3)
       dimension del1(3),del2(3)

C
       common/paramODF/paramODF(NumParODF)
       common/res/ResField(NUMPOINT),ResSpec(NUMPOINT),delta
       common/value1/spin(MAXNUCL),spinm(MAXNUCL,MAXNUCL),
     *GN(MAXNUCL),DELF, HSRED,Fscale,EPS,TNET(2),XL(3,2)
       common/value11/ncomp(MAXNUCL),IEQ(MAXNUCL)
  
       common /APROM/G2X,G2Y,g2Z,A2X(MAXNUCL),A2Y(MAXNUCL),A2Z(MAXNUCL),
     +  GA2X(MAXNUCL),GA2Y(MAXNUCL),GA2Z(MAXNUCL)

       common/old1/HW,HWBET,gausM(3,3),aLorM(3,3)
       common/old11/nucl1,nucl2,Kshape1,Kshape2,Kfft
     
       common/TUG/ tug1(3,3,MAXNUCL), tug2(3,3,MAXNUCL)
       common/value2/spinm2(MAXNUCL,MAXNUCL),prspin(MAXNUCL,MAXNUCL)

       common/resFieldIn/ResFieldIn(NUMPOINT)
c
      double precision PI
      parameter (PI=3.1415926535897932384626433832795D0)
      parameter (be=4.6688D-5, coe=PI/180.d0)
      parameter(AnuclMag=2.54277d-8) !2.54277d-8 - nuclear magneton in cm-1
             EXTERNAL FUNC1, FUNC2
             EXTERNAL FUNC1t, FUNC2t
c

      common/hi/eHi(3)
      common /temptemp/ispectr
      
C   Shift  
    
      DO i=1,key(3)
            ResField(i)=ResFieldIn(i)+par(1)
      END DO 

      hi=ugol*coe
      eHi(1)=0.d0
      eHi(2)=-dsin(hi)
      eHi(3)=dcos(hi)


      TNET(1)=key(4)
      TNET(2)=key(4)  
c
       HW=par(2)
      nucl1=key(13)
      Kshape1=key(11)
      Kshape2=key(12)
      Kfft=key(15)
c
                      val0=0.0d0
        HWBET=HW/BE 
       G(1)=par(16)
       G(2)=par(17)  
       G(3)=par(18)
       G2X=par(16)**2
       G2Y=par(17)**2  
       G2Z=par(18)**2
                DO I=1,NUCL1
          A2X(I)=(be*par(16)*par(37+6*(I-1)))**2
          A2Y(I)=(be*par(17)*par(38+6*(I-1)))**2
          A2Z(I)=(be*par(18)*par(39+6*(I-1)))**2
          GA2X(I)=G2X*A2X(I)
          GA2Y(I)=G2Y*A2Y(I)
          GA2Z(I)=G2Z*A2Z(I)
         END DO   
      IF (Kshape1.EQ.1) THEN
C preparation for gauss line
      del1(1)=par(4)*par(4)
      del1(2)=par(5)*par(5)
      del1(3)=par(6)*par(6)
       FiTePsi(1)=par(7)*coe
       FiTePsi(2)= par(8)*coe
       FiTePsi(3)= par(9)*coe
       call EulerTrans(FiTePsi,del1,GausM)
       ENDIF
C preparation for lorench line 
      IF (Kshape2.EQ.1) THEN
      del2(1)=par(10)*par(10)
      del2(2)=par(11)*par(11)
      del2(3)=par(12)*par(12)
        FiTePsi(1)=par(13)*coe
        FiTePsi(2)= par(14)*coe
        FiTePsi(3)= par(15)*coe
       call EulerTrans( FiTePsi,del2,aLorM)
      END IF
c
        Wtran=1.d0
      goto(11,12,12,12) key(9)
 11    continue
C      ESRMOD1
      do 22 numnucl=1,nucl1
          do 21 j=1,ncomp(numnucl) 
         spinm2(numnucl,j)=spinm(numnucl,j)**2 
         prspin(numnucl,j)=SPIN(numnucl)*(SPIN(numnucl)+1.D0)
     *    -spinm2(numnucl,j)
   21   continue
   22   continue 

c
       IF ((Kshape1.GE.2).OR.(Kshape2.GE.2))  THEN
            call PrepRak(key,par)  !Line width, Rakitin
            CALL INKOR(key(3),3,TNET,1,XL,FUNC1t,SpecMod,val0)
       ELSE      !ORDINARY LINE WIDTH
            CALL INKOR(key(3),3,TNET,1,XL,FUNC1,SpecMod,val0)
       ENDIF

      GOTO 100
 12       continue
c      ESRMOD2
             do 20 i=1,nucl1
       DH(i,1)=par(NfirstSTV+6*(i-1))
       DH(i,2)= par(NfirstSTV+1+6*(i-1))
       DH(i,3)= par(NfirstSTV+2+6*(i-1))
       Wtran=Wtran*(2.d0*spin(i)+1.d0)
 20       continue
       do i=1,nucl1
       j=(i-1)*6

       FiTePsi(3)=par(NfirstSTV+3+j)*coe
       FiTePsi(2)= par(NfirstSTV+4+j)*coe
       FiTePsi(1)= par(NfirstSTV+5+j)*coe

        call EulerMat(FiTePsi,s2,c2,u)
            do  l=1,3
               do  k=1,3
               t=DH(i,k)*g(k)*be
               c1=t*u(k,l)*g(l)/2.d0
c  2.54277d-8 - nuclear magneton in cm-1
               tug2(k,l,i)=u(k,l)*HWBET*AnuclMag*gn(i)-c1
               tug1(k,l,i)= tug2(k,l,i)+2.D0*c1
                    end do
            end do
      enddo
        IF ((Kshape1.GE.2).OR.(Kshape2.GE.2)) THEN
          call PrepRak(key,par)  !Line width, Rakitin
        ENDIF
c
       IF ((Kshape1.GE.2).OR.(Kshape2.GE.2))  THEN
c line width from Rakitin, p 111, (3.23)
            call PrepRak(key,par)  
            CALL INKOR(key(3),3,TNET,1,XL,FUNC2t,SpecMod,val0)
       ELSE      !ORDINARY LINE WIDTH
            CALL INKOR(key(3),3,TNET,1,XL,FUNC2,SpecMod,val0)
       ENDIF
c
  100     CONTINUE 
      do i=1,key(3)
      ResSpec(i)=SpecMod(i,1)/Wtran
      enddo
c       call promOUT(key(3),Resfield,SpecMod)

        return
      end
c #######################################################################

