C for ODF3_1 10/04/2012

c EulerMat.for
        SUBROUTINE EulerMat(ANGLES,s2,c2,RES)
       IMPLICIT DOUBLE PRECISION (A-H),DOUBLE PRECISION (O-Z)       

       DIMENSION ANGLES(3),RES(3,3)

      c1=dcos(angles(1))
      c2=dcos(angles(2))
      c3=dcos(angles(3))
      s1=dsin(angles(1))
      s2=dsin(angles(2))
      s3=dsin(angles(3))

ctemp Zar, (3.37) on p.90
ctemp      RES(1,1)=c1*c2*c3-s1*s3
ctemp      RES(2,1)=s1*c2*c3+c1*s3
ctemp      RES(3,1)=-s2*c3
ctemp      RES(1,2)=-c1*c2*s3-s1*c3
ctemp      RES(2,2)=-s1*c2*s3+c1*c3
ctemp      RES(3,2)=s2*s3
ctemp      RES(1,3)=c1*s2
ctemp      RES(2,3)=s1*s2
ctemp      RES(3,3)=c2

ctemp Zar, (3.36) on p.90
      RES(1,1)=c1*c2*c3-s1*s3
      RES(1,2)=s1*c2*c3+c1*s3
      RES(1,3)=-s2*c3
      RES(2,1)=-c1*c2*s3-s1*c3
      RES(2,2)=-s1*c2*s3+c1*c3
      RES(2,3)=s2*s3
      RES(3,1)=c1*s2
      RES(3,2)=s1*s2
      RES(3,3)=c2

       RETURN
       END
c##########################################################
        SUBROUTINE EulerTrans( FiTePsi,diag,Res)
       IMPLICIT DOUBLE PRECISION (A-H),DOUBLE PRECISION (O-Z)       
       DIMENSION diag(3),FiTePsi(3),umatr(3,3),Res(3,3),rr(3,3)

        call EulerMat(FiTePsi,s2,c2,umatr)

      do 1 j=1,3
         do 1 i=1,3
  1           rr(j,i)=diag(i)*umatr(j,i)
c
      do 2 i=1,3 
         do 2 j=1,3
  2   res(i,j)=rr(i,1)*umatr(j,1)+rr(i,2)*umatr(j,2)+rr(i,3)*umatr(j,3)

      return
      end
c##########################################################
