C for ODF3_1 10/04/2012

C SUBROUTINE-FUNCTION INTEGRAND 
C for simulation with nuclear Zeeman interection(ESRMOD2)
        SUBROUTINE FUNC2(NTOCH,NUMINT,ANGLES,FUNS)
       IMPLICIT DOUBLE PRECISION (A-H),DOUBLE PRECISION (O-Z)       
C
       include 'NumParam.inc'
      parameter  (absolut=1.0d-15 )
c       include 'MATDIM.inc'

       DIMENSION ANGLES(3),FUNS(NUMPOINT)
c3 change
C       common/HN/ hn1(3,10), hn2(3,10), hm1(10), hm2(10)
        dimension hn1(3,MAXNUCL), hn2(3,MAXNUCL)
        dimension  hm1(MAXNUCL), hm2(MAXNUCL)
         dimension e(3),estr(3),ABG(3,3) 
       common/res/ResField(NUMPOINT),ResSpec(NUMPOINT),delta
       common/old1/HW,HWBET,gausM(3,3),aLorM(3,3)
        common/old11/nucl1,nucl2,Kshape1,Kshape2,Kfft

      common/value1/spin(MAXNUCL),spinm(MAXNUCL,MAXNUCL),
     *GN(MAXNUCL),DELF, HSRED,Fscale,EPS,TNET(2),XL(3,2)
        common/value11/ncomp(MAXNUCL),IEQ(MAXNUCL)

       common /APROM/G2X,G2Y,g2Z,A2X(MAXNUCL),A2Y(MAXNUCL),A2Z(MAXNUCL),
     +  GA2X(MAXNUCL),GA2Y(MAXNUCL),GA2Z(MAXNUCL)
       common /mp/smp(MAXTRAN,MAXNUCL),smpstr(MAXTRAN,MAXNUCL)
         common /mp1/numtran

       common/TUG/ tug1(3,3,MAXNUCL), tug2(3,3,MAXNUCL)
c
      parameter (be=4.6688D-5)
c
      common/hi/eHi(3)
      common/ODF1/Jmax

Comments see Func1      
        call EulerMat(ANGLES,s2,c2,ABG)
  
C e(i)- direction cosine for magnetic field in gF
       e(1)=ABG(1,1)*eHi(1)+ABG(1,2)*eHi(2)+ABG(1,3)*eHi(3)
       e(2)=ABG(2,1)*eHi(1)+ABG(2,2)*eHi(2)+ABG(2,3)*eHi(3)
       e(3)=ABG(3,1)*eHi(1)+ABG(3,2)*eHi(2)+ABG(3,3)*eHi(3) 
 
C estr(i)- direction cosine for magnetic field H1 in gF
       estr(1)=ABG(1,1)
       estr(2)=ABG(2,1)
       estr(3)=ABG(3,1) 

       CALL LineWidth(Ilabel,delga,dellor,dellor2,OEFFF,OEFF1,e)
       
       raznost=1.d0-dabs(e(3))
       if(raznost.LE.absolut) then
       COTET=1.d0   !!! TETA=0
       COSFI=1.d0   !!! FI is arbitrary
      else
       COTET=e(3)
       COSFI=e(2)/dsin(dacos(e(3)))
Ctemp        COSFI=e(1)/dsin(dacos(e(3)))
      end if 
       
          CO2TET=COTET*COTET
            CO2FI=COSFI*COSFI

      G2PERP=G2X+(G2Y-G2X)*COSFI*COSFI
Ctemp            G2PERP=G2Y+(G2X-G2Y)*CO2FI            
            g2eff=G2perp+(G2Z-G2PERP)*COTET*COTET
c            prom=COTET*COTET*(G2PERP-G2X)*(G2Y-G2PERP)/G2PERP+G2PERP
c            WW=(G2X*G2Y/G2PERP+G2Z*PROM/G2EFF)/8.D0
c !formula (3.38) in Gidomirov!
          WW=(G2X*G2Y*(estr(1)*e(2)-e(1)*estr(2))**2+
     *        G2Y*G2Z*(estr(2)*e(3)-e(2)*estr(3))**2+
     *        G2Z*G2X*(estr(3)*e(1)-e(3)*estr(1))**2)/G2EFF/4.D0 
       

       geff=dsqrt(g2eff)

           call flocal(nucl1,geff,e,tug1, hn1, hm1) 
         call flocal(nucl1,geff,e,tug2, hn2, hm2) 
         DO IINT=1,NTOCH
              FUNS(IINT)=0.d0 
         END DO
c       
      do 20 itran=1,numtran
      call poss(nucl1,itran,Ptran,hn1,hn2,hm1,hm2)
            sll=0.d0
                  do i=1,nucl1
                  sll=sll+hm2(i)*smpstr(itran,i)-hm1(i)*smp(itran,i)
                  end do 
            sll=(HWBET-sll/be)/geff      
      DO 21 IINT=1,NTOCH
                        po1=ResField(IINT)- SLL
        CALL LineShape(Ilabel,delga,dellor,dellor2,OEFF1,po1,F2)
        FUNS(IINT)=FUNS(IINT)+F2*Ptran
  21   continue
  20   continue
  
      call DISTFUN(Jmax,c2,angles(3),RO)
      
       DO IINT=1,NTOCH
       FUNS(IINT)=FUNS(IINT)*RO*s2*OEFFF*WW
ctemp       FUNS(IINT)=FUNS(IINT)*RO*s2*OEFFF
       END DO 

       if      (Ilabel.eq.202) then
c here CONVOLUTION BY FFT
         call gconvl(FUNS,delga,delta,NTOCH)
       endif

       RETURN
       END
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
       subroutine flocal(n,geff,e,tt, hn, hm)
C This block calculates the local magnetic fields on the nuclei
       IMPLICIT DOUBLE PRECISION (A-H),DOUBLE PRECISION (O-Z)       
       dimension tt(3,3,10), hn(3,10), hm(10)
       dimension e(3)
c       integer n
        do 1 i=1,n
        r=0.D0
       do 2 j=1,3
        s=0.D0
       do 3 k=1,3
    3   s=s+tt(j,k,i)*e(k)
       s=s/geff
       r=r+s*s
    2  hn(j,i)=s
    1  hm(i)=dsqrt(r)
       return
       end
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C---------------------------------------------------------------------
C#####################################################################
       subroutine poss(n,itran,p,hn1,hn2,hm1,hm2)
C This block calculates the probalities of transitions.
       IMPLICIT DOUBLE PRECISION (A-H),DOUBLE PRECISION (O-Z)       

       include 'NumParam.inc'
c       include 'MATDIM.inc'

c3 change
C       common/HN/ hn1(3,10), hn2(3,10), hm1(10), hm2(10)
        dimension hn1(3,MAXNUCL), hn2(3,MAXNUCL)
        dimension  hm1(MAXNUCL), hm2(MAXNUCL)
      common/value1/spin(MAXNUCL),spinm(MAXNUCL,MAXNUCL),
     *GN(MAXNUCL),DELF, HSRED,Fscale,EPS,TNET(2),XL(3,2)
        common/value11/ncomp(MAXNUCL),IEQ(MAXNUCL)

       common /mp/smp(MAXTRAN,MAXNUCL),smpstr(MAXTRAN,MAXNUCL)
         common /mp1/numtran

      real a
c
        p=1.d0
       do 11 i=1,n
         a=(hn1(1,i)*hn2(1,i)+hn1(2,i)*hn2(2,i)+hn1(3,i)*hn2(3,i))
     *   /hm1(i)/hm2(i)
        IF (spin(i).EQ.0.5) then
         ac=(1.D0+a)/2.d0
         as=(1.D0-a)/2.d0
c Calculations for spin 1/2
            if (smp(itran,i)*smpstr(itran,i).LT.0) then
               t=as
            else
               t=ac
            endif
            p=p*t
            go to 11
        endif
c Calculations for spin more then 1/2
         ac=dsqrt((1.D0+a)/2.d0)
         as=dsqrt((1.D0-a)/2.d0)
        call formula(rmm,Spin(i),smp(itran,i),smpstr(itran,i),ac,as)
        p=p*rmm*rmm
c      write(*,*)p,rmm
  11  continue      
        return
        end
c###############################################################
       SUBROUTINE formula(rmm,AInucl,AMPi,AMPr,cos,sin)
       IMPLICIT DOUBLE PRECISION (A-H),DOUBLE PRECISION (O-Z)
c      REAL       FAC
c      EXTERNAL   FAC 
c formula 3.68, p.97 Gidomiriv,Lebedev
c
      it=0
      IpMPi=int(AInucl+AMPi)
      ImMPi=int(AInucl-AMPi)
      IpMPr=int(AInucl+AMPr)
      ImMPr=int(AInucl-AMPr)
      MPimMPr=int(AMPi-AMPr)
c
      itmax=IpMPi
      if (ImMPr.gt.itmax)then
      itmax=ImMPr
      endif
      it=0
      rmm=0.d0
      do while (it.le.itmax)
      if ((IpMPi-it).ge.0)then
      ZN1=FACmy(IpMPi-it)
      else 
      goto 10
      endif
      if ((ImMPr-it).ge.0)then
      ZN2=FACmy(ImMPr-it)
      else 
      goto 10
      endif
      if ((it-MPimMPr).ge.0)then
      ZN3=FACmy(it-MPimMPr)
      else 
      goto 10
      endif
      prom=sqrt(FACmy(IpMPi)*FACmy(ImMPi)*FACmy(IpMPr)*FACmy(ImMPr))
      prom1=(-1)**it*prom/ZN1/ZN2/ZN3/FACmy(it)
      prom2=prom1*cos**(IpMPi+ImMPr-2*it)
      prom3=prom2*sin**(2*it-MPimMPr)
      rmm=rmm+prom3
10    it=it+1
      enddo !while
      return
      end
c###############################################################
       DOUBLE PRECISION FUNCTION FACmy(I)

       integer I
C
        FACmy=1.d0 
        II=I
        DO while (II.gt.1)
          FACmy=FACmy*II
          II=II-1
        enddo
       RETURN
       END
c###############################################################

