C for ODF3_1 10/04/2012

C SUBROUTINE-FUNCTION INTEGRAND 
C for simulation with nuclear Zeeman interection(ESRMOD2)    
        SUBROUTINE FUNC2t(NTOCH,NUMINT,ANGLES,FUNS)
       IMPLICIT DOUBLE PRECISION (A-H),DOUBLE PRECISION (O-Z)       
C
       include 'NumParam.inc'
      parameter  (absolut=1.0d-15 )
     
c      include 'MATDIM.inc'

       DIMENSION ANGLES(3),FUNS(NUMPOINT),F2(NUMPOINT)
c3 change
C       common/HN/ hn1(3,10), hn2(3,10), hm1(10), hm2(10)
        dimension hn1(3,MAXNUCL), hn2(3,MAXNUCL)
        dimension  hm1(MAXNUCL), hm2(MAXNUCL)
         dimension e(3),estr(3),e2(3),ABG(3,3) 
       common/res/ResField(NUMPOINT),ResSpec(NUMPOINT),delta
       common/old1/HW,HWBET,gausM(3,3),aLorM(3,3)
        common/old11/nucl1,nucl2,Kshape1,Kshape2,Kfft

       DOUBLE COMPLEX promc,arg,argz,erffun
      common/value1/spin(MAXNUCL),spinm(MAXNUCL,MAXNUCL),
     * GN(MAXNUCL),DELF, HSRED,Fscale,EPS,TNET(2),XL(3,2)
        common/value11/ncomp(MAXNUCL),IEQ(MAXNUCL)

       common /APROM/G2X,G2Y,g2Z,A2X(MAXNUCL),A2Y(MAXNUCL),A2Z(MAXNUCL),
     + GA2X(MAXNUCL),GA2Y(MAXNUCL),GA2Z(MAXNUCL)
       common /mp/smp(MAXTRAN,MAXNUCL),smpstr(MAXTRAN,MAXNUCL)
         common /mp1/numtran

       common/TUG/ tug1(3,3,MAXNUCL), tug2(3,3,MAXNUCL)
      common/promsig/ promsigxG(MAXNUCL+1,MAXTRAN),
     * promsigyG(MAXNUCL+1,MAXTRAN),promsigzG(MAXNUCL+1,MAXTRAN),
     * promsigxL(MAXNUCL+1,MAXTRAN),promsigyL(MAXNUCL+1,MAXTRAN),
     * promsigzL(MAXNUCL+1,MAXTRAN)
c
      double precision PI
      parameter (PI=3.1415926535897932384626433832795D0)
      parameter (SQTWO=1.4142135623730950488016887242097D0)
      parameter (SQTHREE=1.7320508075688772935274463415059D0)
      parameter (SQPI=1.7724538509055160272981674833411D0)
c      DOUBLE COMPLEX, parameter::im=(0.d0,1.d0)
c
      parameter (OEFFG=SQTWO/SQPI/PI) !OEFFG= DSQRT(2.d0/PI)/PI  
      parameter(OEFFL=SQTHREE/(2.0d0*PI*PI)) !OEFFL= DSQRT(3.d0)/(2*PI*PI)
      parameter ( OEFF1L= 3.d0/4.d0) 
      parameter (OEFFC=2.d0/SQPI/PI) !OEFFC= 2.0d0/DSQRT(PI)/PI  
      parameter ( OEFF2C= SQTHREE/SQTWO) 
      parameter (be=4.6688D-5, coe=PI/180.d0)
c
      common/hi/eHi(3)
      common/ODF1/Jmax
      common /Ilabel/Ilabel
     
Comments see Func1 
        call EulerMat(ANGLES,s2,c2,ABG)
  
C e(i)- direction cosine for magnetic field in gF
       e(1)=ABG(1,1)*eHi(1)+ABG(1,2)*eHi(2)+ABG(1,3)*eHi(3)
       e(2)=ABG(2,1)*eHi(1)+ABG(2,2)*eHi(2)+ABG(2,3)*eHi(3)
       e(3)=ABG(3,1)*eHi(1)+ABG(3,2)*eHi(2)+ABG(3,3)*eHi(3) 
  
C estr(i)- direction cosine for magnetic field H1 in gF
       estr(1)=ABG(1,1)
       estr(2)=ABG(2,1)
       estr(3)=ABG(3,1) 

       raznost=1.d0-dabs(e(3))
       if(raznost.LE.absolut) then
       COTET=1.d0   !!! TETA=0
       COSFI=1.d0   !!! FI is arbitrary
       else
       COTET=e(3)
       COSFI=e(2)/dsin(dacos(e(3)))
       end if 
       
          CO2TET=COTET*COTET
            CO2FI=COSFI*COSFI

      e2(1)=e(1)*e(1)
      e2(2)=e(2)*e(2)
      e2(3)=e(3)*e(3) 
       
            G2PERP=G2X+(G2Y-G2X)*COSFI*COSFI
            g2eff=G2perp+(G2Z-G2PERP)*COTET*COTET
c            prom=COTET*COTET*(G2PERP-G2X)*(G2Y-G2PERP)/G2PERP+G2PERP
c            WW=(G2X*G2Y/G2PERP+G2Z*PROM/G2EFF)/8.D0
c !formula (3.38) in Gidomirov!
          WW=(G2X*G2Y*(estr(1)*e(2)-e(1)*estr(2))**2+
     *        G2Y*G2Z*(estr(2)*e(3)-e(2)*estr(3))**2+
     *        G2Z*G2X*(estr(3)*e(1)-e(3)*estr(1))**2)/G2EFF/4.D0 
       
      
       geff=dsqrt(g2eff)
c
          call flocal(nucl1,geff,e,tug1, hn1, hm1) 
         call flocal(nucl1,geff,e,tug2, hn2, hm2) 
         DO IINT=1,NTOCH
              FUNS(IINT)=0.d0 
         END DO

c       
      do 20 itran=1,numtran
        call poss(nucl1,itran,Ptran,hn1,hn2,hm1,hm2)
        SELECT CASE (Ilabel)
c dellin is calculated by (3.25), p.112, Rakitin
        case (101)
         delga2=(e2(1)*promsigxG(1,itran)+e2(2)*promsigyG(1,itran)+
     *        e2(3)*promsigzG(1,itran))/g2eff 
         delga=dsqrt(delga2)
             OEFFF=OEFFG/delga
               OEFF1=-2.d0/delga2  
        case (201)
         dellor2=(e2(1)*promsigxL(1,itran)+e2(2)*promsigyL(1,itran)+
     *        e2(3)*promsigzL(1,itran))/g2eff 
         dellor=dsqrt(dellor2)
                  OEFFF=dellor*OEFFL
        case (202)
         delga2=(e2(1)*promsigxG(1,itran)+e2(2)*promsigyG(1,itran)+
     *        e2(3)*promsigzG(1,itran))/g2eff 
         dellor2=(e2(1)*promsigxL(1,itran)+e2(2)*promsigyL(1,itran)+
     *        e2(3)*promsigzL(1,itran))/g2eff 
         delga=dsqrt(delga2)
         dellor=dsqrt(dellor2)
                   OEFFF=dellor*OEFFL
              OEFF1=OEFF1L*dellor2
        case (301)
         delga2=(e2(1)*promsigxG(1,itran)+e2(2)*promsigyG(1,itran)+
     *        e2(3)*promsigzG(1,itran))/g2eff 
         dellor2=(e2(1)*promsigxL(1,itran)+e2(2)*promsigyL(1,itran)+
     *        e2(3)*promsigzL(1,itran))/g2eff 
         delga=dsqrt(delga2)
         dellor=dsqrt(dellor2)
                  OEFFF=OEFFC/delga2
        END SELECT
            sll=0.d0
                  do i=1,nucl1
                  sll=sll+hm2(i)*smpstr(itran,i)-hm1(i)*smp(itran,i)
                  end do 
            sll=(HWBET-sll/be)/geff      
        DO 21 IINT=1,NTOCH
                        po1=ResField(IINT)- SLL
          SELECT CASE (Ilabel)
                  case (101)
C forma linii - gauss,in differential form
                        po2=oeff1*po1*po1
                        F2(IINT)=-OEFF1*PO1*EXP(PO2)
             case (201:202)
C forma linii - lorench (differential form)
                            PROM=PO1*PO1+OEFF1L*dellor*dellor
                        F2(IINT)=PO1/(PROM*PROM) 
             case (301)
C FORMA LINII - CONVOLUTION OF GAUSS AND LORENTZ
             argz=cmplx(PO1*SQTWO/delga,OEFF2C*dellor/delga)
             arg=-argz*(0.d0,1.d0) 
             call dcerfc(1,arg,erffun)             
             promC=argz*erffun  
             F2(IINT)=dreal(promc)
          END SELECT
  21    continue

        IF (Ilabel.EQ.202) then
c here CONVOLUTION BY FFT
             call gconvl(F2,delga,delta,NTOCH)
        ENDIF

        DO IINT=1,NTOCH ! spectrum   
          FUNS(IINT)=FUNS(IINT)+F2(IINT)*Ptran*OEFFF
        ENDDO
  20  continue

      call DISTFUN(Jmax,c2,angles(3),RO)
       
       DO IINT=1,NTOCH
         FUNS(IINT)=FUNS(IINT)*RO*s2*WW
ctemp         FUNS(IINT)=FUNS(IINT)*RO*s2
       END DO                 

       RETURN
       END
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
