C for ODF3_1 10/04/2012

      SUBROUTINE INPNameD(numSim,Nnames,ZHiExp) 
c      SUBROUTINE read the names of files to be used 
c        ameSpecinp - experimental spectra
c      ameSpecres - results of simulation
c      ameparinp - initial parameters of paramagnetic centers
c       ameparres - result parameters of paramagnetic centers
c      parinpODF - initial parameters of ODF
c      parresODF - result parameters of ODF
c      NamesTrn - contains transitions that should be taken into account
*********************************************************************
c       numsim - number of consecutive simulations 
c      Nnames - numbers of  experimental spectra for each simulation
c      ZHiExp - experimental angles of turn
*********************************************************************
       IMPLICIT DOUBLE PRECISION (A-H),DOUBLE PRECISION (O-Z)
       include 'NumParam.inc'
       include 'Name.inc'
       dimension Nnames(MaxCALC), ZHiExp(MaxExpSpec,MaxCALC)
       common  Snorm(MaxExpSpec,MaxCALC)
       CHARACTER*3 tempStr

      
c          write(*,*) ' INPUT FILENAME FOR SPECTRA ' 
          OPEN ( UNIT=1,FILE='nameODF3.nam',status='old')         
       numSim=0
         READ(1,*)tempStr
      DO 38 WHILE (((LGT(tempStr,'end')).OR.
     *(LLT(tempStr,'end'))).AND.(numSim.LE.MaxCALC))
         numSim=numSim+1

         READ(1,*,ERR=36) ameparinp(numSim),parinpODF(numSim),
     *                    NamesTrn(numSim),Nnames(numSim)
         WRITE(*,100) numSim,ameparinp(numSim),parinpODF(numSim)
         READ(1,*,ERR=36) ameparres(numSim),parresODF(numSim)
         WRITE(*,101) ameparres(numSim),parresODF(numSim) 

         DO i=1,Nnames(numSim)
           READ(1,*,ERR=37) ameSpecinp(i,numSim),ameSpecres(i,numSim),
     *                      ZHiExp(i,numSim),Snorm(i,numSim)
           WRITE(*,102)ameSpecinp(i,numSim),ameSpecres(i,numSim),
     *                  ZHiExp(i,numSim)
  37       continue !error handling
         ENDDO

 100         format(1x,'Simulation ',1x,I2,':',1x,A12,1x,A12)
 101         format(10x,A12,1x,A12)
 102         format(1x,'files : ',A12,1x,A12,F8.2)

         READ(1,*,ERR=36)tempStr
  36   continue !error handling
  38   enddo !while
         CLOSE (UNIT=1)
       
       return
       end
