C for ODF3_1 10/04/2012

       subroutine prepval(keys,pars,ametrn)
c        Subroutine prepare need constants and values,   
c        which is not changed in course minimization.
c        Subroutine copies  parins to pars
          IMPLICIT DOUBLE PRECISION (A-H),DOUBLE PRECISION (O-Z)
C
       include 'NumParam.inc'
       include 'DIMkeys.inc'
       include 'Spins.inc'

      double precision PI
       include 'const.inc'

       dimension par(NUMPAR)
c3 change
c      common/drian/PZ(MAXTRAN)
       dimension state(500,MAXNUCL)
       dimension Ptran(MAXTRAN),smt(MAXNUCL),smst(MAXNUCL)   

       dimension PZ(MAXTRAN)
C
         common /mps/smps(MAXTRAN,MAXNUCL,NUMCENTER),
     * smpstrs(MAXTRAN,MAXNUCL,NUMCENTER)
        common /mps1/numtrans(NUMCENTER)

      common/value1/spin(MAXNUCL),spinm(MAXNUCL,MAXNUCL),
     *GN(MAXNUCL),DELF, HSRED,Fscale,EPS,TNET(2),XL(3,2)
        common/value11/ncomp(MAXNUCL),IEQ(MAXNUCL)
  
        common /mp/smp(MAXTRAN,MAXNUCL),smpstr(MAXTRAN,MAXNUCL)
         common /mp1/numtran

       common /mpTemp/smpT(NUMPOINT,MAXNUCL),smpstrT(NUMPOINT,MAXNUCL)
       common /ProbTrans/ParTrans
      common /parsin/parsin


      character*12 ametrn,strtemp
C
      
C
       Logical fileTR
c      ****************************************************************
              fileTR=.FALSE.     

       HWBET=pars(2,1)/BE
       
c
      XL(1,1)=0.D0
      XL(1,2)=2.d0*PI
      XL(2,1)=0.D0
      XL(2,2)=PI
      XL(3,1)=0.D0
      XL(3,2)=2.d0*PI

c      just nukl1 (N anisotr. nucl) are taken into account
c   isotropic nuclei  and group of protons should be taken as anistropic nuclei
c      nucl1 - key(13)
c for MOD1
      do js=1,keys(2,1)
         if (keys(9,js).eq.3)then
              fileTR=.TRUE.     
       OPEN ( UNIT=3,FILE=ametrn)
         write(3,*)ametrn
       CLOSE (UNIT=3)     
         endif
      enddo
      do js=1,keys(2,1)
               if ((keys(9,js).eq.4).and.fileTR) then
              keys(9,js)=3
          endif
      enddo
c
      do js=1,keys(2,1)
        do 31 i=1,keys(13,js)
   31       ncomps(i,js)=int(2.d0*spins(i,js))+1
c   
       do 32 j1=1,keys(13,js)   
          do 32 j=0,ncomps(j1,js)-1
   32       spinms(j1,j+1,js)=spins(j1,js)-j

c for MOD2
          do 33 i=1,keys(13,js)
   33         state(1,i)=spins(i,js)
c calculation of the number of states


      nstate=1
      ns=1
       do 40 i=1,keys(13,js)
          do 41 j=2,ncomps(i,js)
             do 42 j1=1,ns
                nstate=nstate+1          
                do 43 j2=1,keys(13,js)
                   state(nstate,j2)=state(j1,j2)
  43                continue
                state(nstate,i)=spinms(i,j,js)
  42             continue
  41          continue
            ns=nstate
  40    continue
c All transitions:  !!!
       OPEN ( UNIT=2,FILE='history', POSITION='APPEND')
       if (keys(9,js).eq.2)then
      numtrans(js)=0
       do  i=1,nstate
          do  j=1,nstate
             numtrans(js)=numtrans(js)+1
         if((numtrans(js)).gt.MAXTRAN) then
                krewrite=krewrite+1
              write(*,*)'Number of transitions is too large!'
              write(*,*)'              Use the mode 3'
              write(2,*)'Number of transitions is too large!'
              write(2,*)'              Use the mode 3'
              stop
              endif
             do j1=1,keys(13,js)
                  smps(numtrans(js),j1,js)=state(i,j1)
                  smpstrs(numtrans(js),j1,js)=state(j,j1)
             enddo
            enddo
         enddo
      endif

c choosing transitions:  !!!
      if (keys(9,js).eq.3)then
                   do j=1,keys(NUMKEY,js)
                    par(j)=pars(j,js)
               enddo
                   do j=1,keys(13,js)
                  spin(j)=spins(j,js)
                    GN(j)=GNs(j,js)
               enddo
      TNET(1)=keys(4,js)
      TNET(2)=keys(4,js)  
c
      numtrans(js)=0
      NtrTemp=0
       do  i=1,nstate
          do  j=1,nstate
             NtrTemp=NtrTemp+1
             do j1=1,keys(13,js)
                  smpT(NtrTemp,j1)=state(i,j1)
                  smpstrT(NtrTemp,j1)=state(j,j1)
             enddo
             if (((nstate*(i-1)+j).EQ.(nstate*nstate)).OR.
     *            (NtrTemp.EQ.1024)) then      
                 call TestTran(js,keys,par,NtrTemp,Ptran)
                 do j2=1,NtrTemp
                    if (Ptran(j2).GT.ParTrans) then
                       numtrans(js)=numtrans(js)+1
                       if((numtrans(js)).LE.MAXTRAN) then
                             do j3=1,keys(13,js)
                           smps(numtrans(js),j3,js)=smpT(j2,j3)
                             smpstrs(numtrans(js),j3,js)=smpstrT(j2,j3)
                           PZ(numtrans(js))=Ptran(j2)
                           enddo
                            endif
                    endif
                 enddo
                 NtrTemp=0
                 write(*,*)js,nstate*nstate,nstate*(i-1)+j,numtrans(js)
                 write(2,*)js,nstate*nstate,nstate*(i-1)+j,numtrans(js)
              endif
            enddo
         enddo
      OPEN ( UNIT=3,FILE=ametrn, POSITION='APPEND')
      write(3,*)js,numtrans(js),keys(13,js)
         do  i=1,numtrans(js)
           write(3,1005)PZ(i),
     *     (smps(i,jj,js),smpstrs(i,jj,js),jj=1,keys(13,js))
1005       FORMAT(G12.4,10(1x,F4.1))
         enddo
       CLOSE (UNIT=3)     
      endif
c
      if (keys(9,js).eq.4)then
        ICON=0
        OPEN ( UNIT=3,FILE=ametrn,ERR=38,status='old')
        numtrans(js)=0
        Read(3,*,ERR=38)strtemp
        Read(3,*,ERR=38)jsold,numtrold,key13old
           if (jsold.LT.js) then
        do  i=1,numtrold
        READ(3,*,ERR=38,IOSTAT=ICON)
     *    Ptr,(smt(jj),smst(jj),jj=1,key13old)
        enddo !numtrold
        Read(3,*,ERR=38)jsold,numtrold,key13old
           endif !jsold
           if (jsold.GT.js) then
c          WRITE (*,101) js,ametrn
c          WRITE (2,101) js,ametrn
c 101  format( 2x,'Unknown transitions for center No ',i2,'in file ',A)
                 ICON=1
           endif !jsold
c 
           if (jsold.EQ.js) then
        do  i=1,numtrold
        READ(3,*,ERR=38,IOSTAT=ICON)
     *    Ptr,(smt(jj),smst(jj),jj=1,keys(13,js))
          if (Ptr.GT.ParTrans) then
            numtrans(js)=numtrans(js)+1
            if((numtrans(js)).LE.MAXTRAN) then
               do j3=1,keys(13,js)
                   smps(numtrans(js),j3,js)=smt(j3)
                     smpstrs(numtrans(js),j3,js)=smst(j3)
               enddo
            else
          WRITE (*,*) 'Number of transitions exceedes 10000 '
          WRITE (2,*) 'Number of transitions exceedes 10000 '
                 ICON=1
            endif
          endif
        enddo !numtrold
       endif !jsold
      goto 39
 38      icon=1
 39         if (icon.gt.0)then
        WRITE (*,*)  'FILE - ',ametrn, 'DO NOT prepared properly'
          WRITE (2,*)  'FILE - ',ametrn, 'DO NOT prepared properly'
          stop
         endif
       CLOSE (UNIT=3)
        endif !keys(9,js)

      if ((keys(9,js).eq.3).or.(keys(9,js).eq.4))then
       write(*,1000)numtrans(js)
       write(2,1000)numtrans(js)
 1000  format( 2x,'Number of transitions is =',i6) 
        CLOSE (UNIT=2)
        if((numtrans(js)).gt.MAXTRAN) then
          write(*,*)'Number of transitions is too large!'
          write(*,*)'  Use the mode 3 '
          write(2,*)'Number of transitions is too large!'
          write(2,*)'  Use the mode 3 '
          stop
        endif
      endif
      enddo !js
c100          continue
 
          return
          end
c________________________________________________________________
c________________________________________________________________
C !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
