C for ODF3_1 10/04/2012

      SUBROUTINE TestTran(jcenter,keys,par,ntran,Ptran)
c  This block calculates the transition probabilities 
c for determination the important ones 
          IMPLICIT DOUBLE PRECISION (A-H),DOUBLE PRECISION (O-Z)
C       
   
       include 'NumParam.inc'
   
c       include 'MATDIM.inc'

       integer  keys(NUMKEY,NUMCENTER)
       dimension par(NUMPAR)
c      dimension resprom(NUMPOINT,2)
c      dimension del1(3),del2(3)
      dimension u(3,3),FiTePsi(3)
        dimension G(3),DH(MAXNUCL,3)
      dimension Ptran(1024)
C
      common/value1/spin(MAXNUCL),spinm(MAXNUCL,MAXNUCL),
     *GN(MAXNUCL),DELF, HSRED,Fscale,EPS,TNET(2),XL(3,2)
        common/value11/ncomp(MAXNUCL),IEQ(MAXNUCL)

       common /APROM/G2X,G2Y,g2Z,A2X(MAXNUCL),A2Y(MAXNUCL),A2Z(MAXNUCL),
     +  GA2X(MAXNUCL),GA2Y(MAXNUCL),GA2Z(MAXNUCL)
       common/old1/HW,HWBET,gausM(3,3),aLorM(3,3)
        common/old11/nucl1,nucl2,Kshape1,Kshape2,Kfft

       common/TUG/ tug1(3,3,MAXNUCL), tug2(3,3,MAXNUCL)
C
      double precision PI
      parameter (PI=3.1415926535897932384626433832795D0)
      parameter (be=4.6688D-5, coe=PI/180.d0)
      parameter(AnuclMag=2.54277d-8) !2.54277d-8 - nuclear magneton in cm-1
C
                   EXTERNAL Protran
c
c
       HW=par(2)
      nucl1=keys(13,jcenter)
c
                      val0=0.0d0
        HWBET=HW/BE 
       G(1)=par(16)
       G(2)=par(17)  
       G(3)=par(18)
       G2X=par(16)**2
       G2Y=par(17)**2  
       G2Z=par(18)**2
                DO I=1,NUCL1
          A2X(I)=(be*par(16)*par(NfirstSTV+6*(I-1)))**2
          A2Y(I)=(be*par(17)*par(NfirstSTV+1+6*(I-1)))**2
          A2Z(I)=(be*par(18)*par(NfirstSTV+2+6*(I-1)))**2
          GA2X(I)=G2X*A2X(I)
          GA2Y(I)=G2Y*A2Y(I)
          GA2Z(I)=G2Z*A2Z(I)
         END DO   

c      ESRMOD2
             do 20 i=1,nucl1
       DH(i,1)=par(NfirstSTV+6*(i-1))
       DH(i,2)= par(NfirstSTV+1+6*(i-1))
       DH(i,3)= par(NfirstSTV+2+6*(i-1))
 20       continue
       do i=1,nucl1
       j=(i-1)*6
c fi and psi  ???!!!
       FiTePsi(1)=par(NfirstSTV+3+j)*coe
       FiTePsi(2)= par(NfirstSTV+4+j)*coe
       FiTePsi(3)= par(NfirstSTV+5+j)*coe
        call EulerMat(FiTePsi,s2,c2,u)

            do  l=1,3
               do  k=1,3
               t=DH(i,k)*g(k)*be
               c1=t*u(k,l)*g(l)/2.d0
c  2.54277d-8 - nuclear magneton in cm-1
               pr=u(k,l)*HWBET
               tug2(k,l,i)=pr*AnuclMag*gn(i)-c1
               tug1(k,l,i)= tug2(k,l,i)+2.D0*c1
                    enddo
            enddo
      enddo
c
         CALL INKOR(ntran,2,TNET,1,XL,ProTran,Ptran,val0)
c 
        do itran=1,ntran
          Ptran(itran)=Ptran(itran)/2.d0/PI
         enddo
c  
        return
      end
c #######################################################################
C SUBROUTINE-FUNCTION INTEGRAND 
C for TestTran with nuclear Zeeman interection
        SUBROUTINE ProTran(ntran,INTMult,ANGLES,PromP)
       IMPLICIT DOUBLE PRECISION (A-H),DOUBLE PRECISION (O-Z)       
C

       include 'NumParam.inc'
c       include 'MATDIM.inc'

       DIMENSION ANGLES(2),PromP(1024)
      common/value1/spin(MAXNUCL),spinm(MAXNUCL,MAXNUCL),
     *GN(MAXNUCL),DELF, HSRED,Fscale,EPS,TNET(2),XL(3,2)
        common/value11/ncomp(MAXNUCL),IEQ(MAXNUCL)

       common /APROM/G2X,G2Y,g2Z,A2X(MAXNUCL),A2Y(MAXNUCL),A2Z(MAXNUCL),
     +  GA2X(MAXNUCL),GA2Y(MAXNUCL),GA2Z(MAXNUCL)
       common/old1/HW,HWBET,gausM(3,3),aLorM(3,3)
        common/old11/nucl1,nucl2,Kshape1,Kshape2,Kfft

       common/TUG/ tug1(3,3,MAXNUCL), tug2(3,3,MAXNUCL)
c3 change
C       common/HN/ hn1(3,MAXNUCL), hn2(3,MAXNUCL), hm1(MAXNUCL), hm2(MAXNUCL)
       dimension hn1(3,MAXNUCL), hn2(3,MAXNUCL)
       dimension hm1(MAXNUCL), hm2(MAXNUCL)
         dimension e(3) 
c       
       SITET=DSIN(ANGLES(1))
       COTET=DCOS(ANGLES(1))
       cosfi=Dcos(ANGLES(2))
            G2PERP=G2X+(G2Y-G2X)*COSFI*COSFI
            g2eff=G2perp+(G2Z-G2PERP)*COTET*COTET
            prom=COTET*COTET*(G2PERP-G2X)*(G2Y-G2PERP)/G2PERP+G2PERP
            WW=(G2X*G2Y/G2PERP+G2Z*PROM/G2EFF)/8.D0       
       e(1)=sitet*Dsin(ANGLES(2))
       e(2)=sitet*cosfi
       e(3)=cotet
c      g2eff=G2X*e(1)**2+G2Y*e(2)**2+G2Z*e(3)**2
       geff=dsqrt(g2eff)
          call flocal(nucl1,geff,e,tug1, hn1, hm1) 
         call flocal(nucl1,geff,e,tug2, hn2, hm2) 
c       
      do 20 itran=1,ntran
          call posstest(nucl1,itran,Pr,hn1,hn2,hm1,hm2)
          PromP(itran)=Pr*SITET
  20   continue 

c       call promOUT(numtran,tr,PromTran)
       RETURN
       END
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C#####################################################################
       subroutine posstest(n,itran,p,hn1,hn2,hm1,hm2)
C This block calculates the probalities of transitions.
       IMPLICIT DOUBLE PRECISION (A-H),DOUBLE PRECISION (O-Z)       
C
       include 'NumParam.inc'
       dimension hn1(3,MAXNUCL), hn2(3,MAXNUCL)
       dimension  hm1(MAXNUCL), hm2(MAXNUCL)
      common/value1/spin(MAXNUCL),spinm(MAXNUCL,MAXNUCL),
     *GN(MAXNUCL),DELF, HSRED,Fscale,EPS,TNET(2),XL(3,2)
        common/value11/ncomp(MAXNUCL),IEQ(MAXNUCL)

       common /mpTemp/smpT(NUMPOINT,MAXNUCL),smpstrT(NUMPOINT,MAXNUCL)
      real a
c
        p=1.d0
       do 11 i=1,n
         a=(hn1(1,i)*hn2(1,i)+hn1(2,i)*hn2(2,i)+hn1(3,i)*hn2(3,i))
     *   /hm1(i)/hm2(i)
        IF (spin(i).EQ.0.5) then
         ac=(1.D0+a)/2.d0
         as=(1.D0-a)/2.d0
c Calculations for spin 1/2
            if (smpT(itran,i)*smpstrT(itran,i).LT.0) then
               t=as
            else
               t=ac
            endif
            p=p*t
            go to 11
        endif
c Calculations for spin more then 1/2
         ac=dsqrt((1.D0+a)/2.d0)
         as=dsqrt((1.D0-a)/2.d0)
      call formula(rmm,Spin(i),smpT(itran,i),smpstrT(itran,i),ac,as)
        p=p*rmm*rmm
c      write(*,*)p,rmm
  11  continue      
        return
        end
c###############################################################
