C for ODF3_1 10/04/2012
C  PROGRAMM OUTPUT
       SUBROUTINE ESROUT(programName,jname,
     * VNev,VNEVPoint,kend,cov,keys,pars,ARGALL)

       IMPLICIT DOUBLE PRECISION (A-H),DOUBLE PRECISION (O-Z)
C
       include 'NumParam.inc'
       include 'DIMkeys.inc'
       include 'Name.inc' 
       include 'Spins.inc'
c      Logical corr

c       include 'MATDIM.inc'  

       character*12 programName
       dimension ARGALL(NumArgAll)
       dimension cov(NumArgAll,NumArgAll)
      common /control/Kcontrol      
      common/ressum/ResSpecComp(NUMPOINT,NUMCENTER,MaxExpSpec)

      common/value1/spin(MAXNUCL),spinm(MAXNUCL,MAXNUCL),
     *GN(MAXNUCL),DELF, HSRED,Fscale,EPS,TNET(2),XL(3,2)
        common/value11/ncomp(MAXNUCL),IEQ(MAXNUCL)

              COMMON /CONVERG/ parsFCTOL, parsXCTOL !ax for NL2def!
      common/KeyErr/keyErr,ANoiseLev
           common /ProbTrans/parsTrans   

         common /mps/smps(MAXTRAN,MAXNUCL,NUMCENTER),
     * smpstrs(MAXTRAN,MAXNUCL,NUMCENTER)
        common /mps1/numtrans(NUMCENTER)

      common /expmat/expmat(MaxExpPoint,2*MaxExpSpec),NNtoch(MaxExpSpec)              
      common /forout/hiexp(MaxExpSpec), expdata(NUMPOINT,MaxExpSpec),
     #      teordata(NUMPOINT,MaxExpSpec)  
      common/resFieldIn/ResFieldIn(NUMPOINT)
      common/jvar/kolvar,jvar,nvarODF,NparODF
      integer(4) NumNeg 
      common/NegVal/NumNeg, anegODF
      common /VnevMY/VnevMY(MaxExpSpec+1),errVal(NumArgAll)
      common /parsin/parsin
      common/Mmadr1/NSET,numame,jSim
       character*14 AA0, AAexp,BBexp
       character*14 AAres,BBres(NUMCENTER+1)
      character*14 Corr(NumArg)



      OPEN ( UNIT=2,FILE='history', POSITION='APPEND')
               write(2,100)ameSpecres(jname,jSim)
 100  FORMAT(3x,'OUTPUT FILE - ',A12)    
       CLOSE (UNIT=2)
    
       OPEN ( UNIT=1,FILE=ameSpecres(jname,jSim))
      WRITE(1,115)programName,ameSpecinp(jname,jSim),
     *            ameparinp(jSim),parinpODF(jSim)
 115      Format(1x,A15,', ',A15,', ',A15,', ',A15) 
         Write(1,*)' Negative number and volume = ', NumNeg, anegODF


 201       write(1,112)kend,VNev, VNEVpoint 
  112   format( 'NL2SOL iv(1)=',i2,'  Fmin=',G10.4,', For point=',G10.4)
 202      write(1,114)VnevMY(Numame+1),VnevMY(Numame+1)/numame/Nset,
     * VnevMY(jname)/Nset
  114       format( ' Discr.= ',G12.4,' Pure =',G12.4,' Spectr =',G12.4) 


 204      write(1,101) keys(1,1),NSET,keys(5,1)
 101  FORMAT(1x,' variat.- ',I2,', spectrum - ',I4,' points, ',
     *'numav - ',i2)       
      write(1,103) DELF,HSRED,Fscale
 103  FORMAT(1x,' Range - ',
     *F7.2,', Centr - ',F10.2, ', FieldScale-',F7.1)       
      write(1,104) EPS,parsFCTOL, parsXCTOL,parsTrans
 104  FORMAT(1x,' EPS=',G8.1,', RFCTOL=',G8.1,', XCTOL=',G8.1,
     * ', parsTrans=',G8.1)
              write(1,105) (pars(j,1),iflags(j,1),j=1,2)
 105  FORMAT(1x,'Sdv,hw ',2(F10.5,1x,I1,1x))
c
c cycle js
       do js=1,keys(2,1)
          write(1,119)js,pars(3,js),iflags(3,js)
 119  FORMAT(1X,'center No - ',I1,', Ampl.factor= ',F10.5,1x,I2)
      if (keys(9,js).eq.4)then
         write(1,118)keys(13,js),keys(4,js),numtrans(js),NamesTrn(jSim)
 118  FORMAT(1X,'Num.nucl- ',I1,', net- ',i6,2x,
     *'numtran=',i6,' from ',A12)
      endif
      if ((keys(9,js).eq.2).or.(keys(9,js).eq.3))then
            write(1,117) keys(13,js),keys(4,js),numtrans(js)
 117  FORMAT(1X,'Num.nucl- ',I1,', net - ',i6,2x, 'numtran=',i5)
      endif
      if (keys(9,js).eq.1)then
            write(1,1171)keys(13,js),keys(4,js)
 1171  FORMAT(1X,'Num.nucl- ',I1,', net - ',i6)
      endif
        SELECT CASE (keys(15,js))
          CASE (2)
             write(1,1022) keys(6,js),keys(9,js)
 1022  FORMAT(1x,' Libr.- ',I1,' Simulation - ',I1,', FFT calc.')       
          CASE (1)
             write(1,1021) keys(6,js),keys(9,js)
 1021  FORMAT(1x,' Libr.- ',I1,' Simulation - ',I1,', My convolution')       
          CASE DEFAULT
             write(1,102) keys(6,js),keys(9,js)
 102  FORMAT(1x,' Libr.- ',I1,' Simulation - ',I1)       
        END SELECT
c reduce angles into interval (-360,360)
      do j1=7,9
        do while (pars(j1,js).ge.360.d0)
           pars(j1,js)=pars(j1,js)-360.d0
        enddo
        do while (pars(j1,js).le.-360.d0)
           pars(j1,js)=pars(j1,js)+360.d0
        enddo
      enddo
      do j1=13,15
        do while (pars(j1,js).ge.360.d0)
           pars(j1,js)=pars(j1,js)-360.d0
        enddo
        do while (pars(j1,js).le.-360.d0)
           pars(j1,js)=pars(j1,js)+360.d0
        enddo
      enddo
c
               write(1,106) (pars(j,js),iflags(j,js),j=4,9)
 106  FORMAT(1x,'Gauss   - '6(G10.4,1x,I2,1x))
               write(1,1061) (pars(j,js),iflags(j,js),j=25,30)
 1061  FORMAT(1x,'bet,gam- '6(G10.4,1x,I2,1x))
               write(1,107) (pars(j,js),iflags(j,js),j=10,15)
 107  FORMAT(1x,'Lorentz - '6(G10.4,1x,I2,1x))
                write(1,1061) (pars(j,js),iflags(j,js),j=31,36)
               write(1,108) (pars(j,js),iflags(j,js),j=16,18)
 108  FORMAT(1x,'g-values- '3(F10.6,1x,I2,1x))
          if (keys(6,js).gt.0) then
               write(1,1081) (parsin(j,js),j=16,18)
 1081  FORMAT(1x,'g-initial- '3(F10.6,1x))
c reduce angles into interval (-360,360)
      do j1=22,24
        do while (pars(j1,js).ge.360.d0)
           pars(j1,js)=pars(j1,js)-360.d0
        enddo
        do while (pars(j1,js).le.-360.d0)
           pars(j1,js)=pars(j1,js)+360.d0
        enddo
      enddo
               write(1,109) (pars(j,js),iflags(j,js),j=19,24)
 109  FORMAT(1x,'Libr  -   '6(G10.4,1x,I2,1x))
       endif
        Npars=NfirstSTV-1
                DO j=1,keys(13,js)
c reduce angles into interval (-360,360)
      do j1=4,6
        do while (pars(Npars+6*(j-1)+j1,js).ge.360.d0)
           pars(Npars+6*(j-1)+j1,js)=pars(Npars+6*(j-1)+j1,js)-360.d0
        enddo
        do while (pars(Npars+6*(j-1)+j1,js).le.-360.d0)
           pars(Npars+6*(j-1)+j1,js)=pars(Npars+6*(j-1)+j1,js)+360.d0
        enddo
      enddo
c
       write(1,110)j,spins(j,js),(pars(Npars+6*(j-1)+i,js),
     *iflags(Npars+6*(j-1)+i,js),i=1,6),GNs(j,js),IEQs(j,js) 
                END DO  
 110  FORMAT(1x,'Nucl.',I1,',Spin=',F3.1,6(1x,G10.4,1x,I2),F9.6,1x,I1)
          if (keys(6,js).gt.0) then
          DO j=1,keys(13,js)
       write(1,1101) (parsin(Npars+6*(j-1)+i,js),i=1,6) 
          END DO  
1101  FORMAT(1x,'Initial Nucl.'6(1x,G10.4))
       endif
        enddo !js      

      if (keyErr.gt.0) then
       do i=1,kolvar
          write(1,111)argall(i),sqrt(cov(i,i))
  111       FORMAT(1x,'var=',G10.4,' Sigma=',G10.4)
          enddo
       AA0=' undefined   ,' 
       if ((kend.gt.2).and.(kend.lt.7)) then
         do i=1,kolvar
           do      j=1,i
              if ((cov(i,i)*cov(j,j)).eq. 0.0D0) then
               Corr(j)=AA0  
            else 
               write(corr(j),505) cov(i,j)/sqrt(cov(i,i)*cov(j,j))
            endif
           enddo
               write(1,506)(corr(jj),jj=1,i)
         enddo
       endif
      endif
  505        FORMAT (G12.4,';')
  506        FORMAT (1X,'C',1X,20(A14))
  113       FORMAT(1x,'Kcorr',20(G12.4,';'))
c
       AA0='             ,' 
            WRITE(1,*)'  Hexp       ,     Sexp     ,',
     *'     Hmod    ,      Smod     '
       DO 10 i=1,MAX(NNtoch(jname),NSET)
            if (expmat(i,2*jname-1).eq.0) then
            AAexp=AA0  
            else 
            write(AAexp,501)expmat(i,2*jname-1)
            endif
            if (expmat(i,2*jname).eq.0) then 
            BBexp=AA0
            else 
            write(BBexp,502)expmat(i,2*jname) 
            endif
            if (RESFieldIn(i).eq.0) then
            AAres=AA0  
            else 
            write(AAres,501)real(RESFieldIn(i))
            endif
            if (teordata(i,jname).eq.0) then 
            BBres(1)=AA0
            else 
            write(BBres(1),502)real(teordata(i,jname)) 
            endif
              nSpecCentr=1
            if (keys(2,1).gt.1) then
              nSpecCentr=keys(2,1)+1
              DO js=1,keys(2,1)
                if (RESSpecComp(i,js,jname).eq.0) then 
                BBres(js+1)=AA0
                else 
                write(BBres(js+1),502)real(RESSpecComp(i,js,jname)) 
                endif
              END DO
            endif
           write(1,503)AAexp,BBexp,
     *  AAres,(BBres(icentr),icentr=1,nSpecCentr)
  10   CONTINUE

c       ******************************************************************
       CLOSE (UNIT=1)

501        FORMAT (1X,F10.4,' ')
502        FORMAT (1X,G12.6,' ')
503        FORMAT (1X,20(8(A14)))

        return
      end

