C for ODF3_1 10/04/2012

      SUBROUTINE LineWidth(Ilabel,delga,dellor,dellor2,OEFFF,OEFF1,e)
       IMPLICIT DOUBLE PRECISION (A-H),DOUBLE PRECISION (O-Z) 
       
      parameter (PI=3.1415926535897932384626433832795D0)
      parameter (SQTWO=1.4142135623730950488016887242097D0)
      parameter (SQTHREE=1.7320508075688772935274463415059D0)
      parameter (SQPI=1.7724538509055160272981674833411D0)

      parameter (OEFFG=SQTWO/SQPI/PI) !OEFFG= DSQRT(2.d0/PI)/PI  
      parameter(OEFFL=SQTHREE/(2.0d0*PI*PI)) !OEFFL= DSQRT(3.d0)/(2*PI*PI)
      parameter ( OEFF1L= 3.d0/4.d0) 
      parameter (OEFFC=2.d0/SQPI/PI) !OEFFC= 2.0d0/DSQRT(PI)/PI  

       common/old1/HW,HWBET,gausM(3,3),aLorM(3,3)
        common/old11/nucl1,nucl2,Kshape1,Kshape2,Kfft
       dimension e(3)   

      IF ((Kfft.EQ.2).and.(Kshape2.GE.1)) THEN 
! FFT calculation      for convolution
        Ilabel=202
          delga=0.d0
        dellor2=0.d0
         do 4 i=1,3
      delga=delga+(e(1)*gausM(i,1)+e(2)*gausM(i,2)+e(3)*gausM(i,3))*e(i) 
         dellor2=dellor2+
     * (e(1)*aLorM(i,1)+e(2)*aLorM(i,2)+e(3)*aLorM(i,3))*e(i)  
   4    continue
        delga=dsqrt(delga)
        dellor=dsqrt(dellor2)
        dellor2=OEFF1L*dellor2
        OEFFF=dellor*OEFFL
      ELSE
c Gauss, Lorentz and my Convolution
         IF (Kshape1.GE.1) THEN
           IF (Kshape2.EQ.1) THEN
c     convolution gauss/lorentz
            Ilabel=301
              delga=0.d0
            dellor2=0.d0
             do 3 i=1,3
      delga=delga+(e(1)*gausM(i,1)+e(2)*gausM(i,2)+e(3)*gausM(i,3))*e(i) 
         dellor2=dellor2+
     * (e(1)*aLorM(i,1)+e(2)*aLorM(i,2)+e(3)*aLorM(i,3))*e(i)  
   3        continue

            OEFFF=OEFFC/delga       !OEFFC/delGauss^2
            delga=dsqrt(delga)
            dellor=dsqrt(dellor2)      
c end for convolution
           ELSE
C forma linii gauss
            Ilabel=101
             delga=0.d0
             do 1 i=1,3
   1  delga=delga+(e(1)*gausM(i,1)+e(2)*gausM(i,2)+e(3)*gausM(i,3))*e(i) 

            OEFF1=-2.d0/delga   !-2.d0/delGauss^2
            delga=dsqrt(delga)
            OEFFF=OEFFG/delga
c end for gauss
           ENDIF !Kshape2
         ELSE 
C forma linii-lorentz
          Ilabel=201
           dellor2=0.d0
           do 2 i=1,3
   2  dellor2=dellor2+
     * (e(1)*aLorM(i,1)+e(2)*aLorM(i,2)+e(3)*aLorM(i,3))*e(i)  
          dellor=dsqrt(dellor2)
          dellor2=OEFF1L*dellor2
          OEFFF=dellor*OEFFL      
c end for lorentz
         END IF !Kshape1
      END IF !Kfft
      return
      end
