C ODF3_1 10/04/2012
C Program find the orientation distribution function by means of simulation of the set
c of ESR spectra recorded for different angles between sample direction and magnetic field. 

 
c       use MSIMSL
          IMPLICIT DOUBLE PRECISION (A-H),DOUBLE PRECISION (O-Z)
      external      MADR1

      EXTERNAL MODSet  
      parameter (TWOPI=2*3.1415926535897932384626433832795D0)

      CHARACTER*12 programName
       include 'constNL2SOL.inc'
       include 'NumParam.inc'
       include 'DIMkeys.inc'
       include 'Name.inc'
       include 'Spins.inc'
       include 'const.inc'


       dimension cov(NumArgAll,NumArgAll)   
       dimension ARG(NUMARG)
       dimension Arres(2,2)
       dimension Nnames(MaxCALC), ZHiExp(MaxExpSpec,MaxCALC)

       integer kboards(NUMBOARD,NUMARG,NUMCENTER)

       Logical FileErr 
       
c******************************************************************************       
     
      common /forout/hiexp(MaxExpSpec), expdata(NUMPOINT,MaxExpSpec),
     #      teordata(NUMPOINT,MaxExpSpec)  
       dimension ARGODF(NumParODF)
       dimension ARGALL(NumParAll)
   

      common /control/Kcontrol
      common / NL2CON / itersToBeDone,itersDone,nl2solOut 
      common/Mmadr1/NSET,numame,jSim 
      COMMON/NCOUNT/LIM,itcount
      COMMON /CONVERG/ PARFCTOL, PARXCTOL          
      common/ODF1/Jmax
      common/jvar/kolvar,jvar,nvarODF,NparODF
      common / STEPJ  / stepJac, stepBound
      common /VnevMY/VnevMY(MaxExpSpec+1),errVal(NumArgAll)
      common /expmat/expmat(MaxExpPoint,2*MaxExpSpec),NNtoch(MaxExpSpec)    
c******************************************************************************         

      common/value1/spin(MAXNUCL),spinm(MAXNUCL,MAXNUCL),
     *GN(MAXNUCL),DELF, HSRED,Fscale,EPS,TNET(2),XL(3,2)
      common/value11/ncomp(MAXNUCL),IEQ(MAXNUCL)
       
      common/exp/FieldExp(NUMPOINT),SpecExp(NUMPOINT)
      common/res/ResField(NUMPOINT),ResSpec(NUMPOINT),delta
      common/resFieldIn/ResFieldIn(NUMPOINT)

      common /chexp/ chexp(NUMPOINT)
      common /user1/kboards
      common /parsin/parsin
      common/weight/weight(MaxExpPoint)
      common/NegVal/NumNeg, anegODF
      common/KeyErr/keyErr,ANoiseLev
c*******************************************************************************
       integer(4) NumNeg 

c      common /temptemp/ispectr

	 ispectr=0
       programName='ODF3_1'

       call INPNameD(numSim,Nnames,ZHiExp) 

      jSim=0

       OPEN ( UNIT=2,FILE='history', POSITION='APPEND')
       WRITE(2,*)programName

 200   jSim=jSim+1
       numame= Nnames(jSim)

       WRITE(2,100) ameparinp(jSim),parinpODF(jSim)
       WRITE(2,100) ameparres(jSim),parresODF(jSim) 
 100       format(1x,A12,1x,A12)
       DO i=1,numame
         hiexp(i)=ZHiExp(i,jSim)
         WRITE(2,101) ameSpecinp(i,jSim),ameSpecres(i,jSim),hiexp(i)
       END DO
 101       format(1x,'files : ',A12,1x,A12,1x,F6.2)

       FileErr=.False.
       CLOSE ( UNIT=2)

       OPEN ( UNIT=1,FILE='Negval.dat',POSITION='APPEND')
          WRITE(1,*)programName
          WRITE(1,100) ameparinp(jSim),parinpODF(jSim)
       CLOSE ( UNIT=1)

      call parread(FileErr,ameparinp(jSim),keys,kboards)     
      call parreadD(parinpODF(jSim))
      call Par_Arg(1,kboards,pars,ARG,ARGODF,ARGALL,keys)

      NSET=keys(3,1)  !number of points in the calculated spectrum 

      NUMAVE=keys(5,1)   !number of points in the extrapolation  
 
c      Preparation of field array 
      delta=DELF*2/(NSET-1)
      Hreg=HSRED-DELF

      DO i=1,NSET
         ResFieldIn(i)=Hreg
         ResField(i)=Hreg
         Hreg=Hreg+delta
      END DO 
       
c      Reading and preparing of the spectra.

      DO i=1,numame
       call specread(FileErr,ameSpecinp(i,jSim),Ntoch,keys(7,1),
     *       Fscale,i,jSim)
       NNtoch(i)=Ntoch
       do l=1,Ntoch
          expmat(l,2*i-1)=FieldExp(l)
          expmat(l,2*i)=SpecExp(l) 
       end do
c      call promout(Ntoch,FieldExp,SpecExp) 
       call chooseExp(NSET,NUMAVE,Ntoch,FieldExp,
     * SpecExp,chexp)
       do j=1,NSET  
          expdata(j,i)=chexp(j)  
       end do
c      call promout(NSET,ArrField,chexp)  
      END DO 
      if (keys(16,1).EQ.1) then
        OPEN ( UNIT=1,FILE='weight.dat')
        do i=1,NSET
           read(1,*) weight(i)
        end do
        CLOSE (UNIT=1)
      else
        do i=1,NSET
           weight(i)=1.0D0
        end do
      end if
      
      call prepval(keys,pars,NamesTrn(jSim))

c************************************************************************************
      if (keyerr.eq.5) then 
          kolvar=kolvar*(-1)
      endif
      VNevPoint=0.0d0
      if (kolvar) 301,301,302

c       Complete restart.
302   continue
      LIM=1
              itCOUNT=0
            stepJac=EPS
            stepBound      =  1.0d0    
            itersToBeDone  =  1000
            nl2solOut  =  -1           ! Short output from NL2SOL.
            itersDone  =  0    ! NL2SOL iteration counter.
            MinToch=numame*NSET
          do i=1,kolvar
              do j=1,i
              cov(i,j)=0.d0
            enddo
          enddo
        do i = 1, MIVD
         iv(i)  =  0 
        end do
        do i = 1, MVD
         v(i)  =  0
        end do
c
      call DFAULT(IV,V)
            iv(1)=12
            iv(21)=2
            
      OPEN ( UNIT=2,FILE='history', POSITION='APPEND')
      
      call NL2SNO(MinToch,kolvar,ARGALL,MADR1,iv,v,keys,pars,MODset)   

              ncovfirst=iv(26)
          if (ncovfirst.eq.-1)then
            write(2,*)'     !!! Hessian is indefined  !!!'
          endif
       CLOSE (UNIT=2)
      if (ncovfirst.gt.3)then
          do i=1,kolvar
              do j=1,i
              cov(i,j)=v(ncovfirst-1+j)
              enddo
          ncovfirst=ncovfirst+i
          enddo
      endif 

      VNEVPoint=V(10)/NSET/numame

      call Par_Arg(2,kboards,pars,ARG,ARGODF,ARGALL,keys)

 301       continue
c       Check of the positive  values of RO

      OPEN ( UNIT=1,FILE='Negval.dat',POSITION='APPEND')
           call ODFint(keys(4,1),anegODF,Arres)
         Write(1,*)' Negative volume = ', anegODF        
       NumNeg=0
       call DISTFUN(Jmax,1.D0,0.0D0,RO)
       if(RO.LT.0.d0) then      
           Write(1,*) 'beta= 0', '  RO=',RO      
           NumNeg=1
       end if
       do j=1,179  
         do i=0,359
          angB=j*coe
          angG=i*coe
          cb=dcos(angB)  
          call DISTFUN(Jmax,cb,angG,RO)
          if(RO.LT.0.d0) then      
              Write(1,*) 'beta=',j,'  gamma=',i,'  RO=',RO      
              NumNeg=NumNeg+1
          end if  
         end do
       end do
       if (NumNeg.EQ.0) then 
           Write(1,*)' There is no a negative value!'
       else 
           Write(1,*)' There are ', NumNeg, ' negative values!'
       endif
      CLOSE(UNIT=1)

        call MODSet(pars,keys)

      VnevMY(numame+1)=0
      do i=1,numame
          VnevMY(i)=0
          do j=1,NSET
            RAZN=teordata(j,i)-expdata(j,i)
            VnevMY(i)=VnevMY(i)+RAZN**2
          end do
          VnevMY(i)=VnevMY(i)/2
          VnevMY(numame+1)=VnevMY(numame+1)+VnevMY(i)
      enddo

c      if (keyerr.ge.4) then
c       call CalcErr(errVal,EPS,ANoiseLev,kolvar,ArgAll,pars,keys)                  
c      endif

      call PARWrite(ameparres(jSim),keys,pars)
      call PARWritD(parresODF(jSim))

      do i=1,numame
       call ESROUT(programName,i,V(10),VNEVPoint,
     * iv(1),cov,keys,pars,ARGAll) 
      enddo         

       OPEN ( UNIT=2,FILE='history', POSITION='APPEND')
       WRITE(2,100) ameparinp(jSim),parinpODF(jSim)
       WRITE(2,100) ameparres(jSim),parresODF(jSim) 
       WRITE (2,*) 'FINISH'

       write(*,*) 'iv(1)=',iv(1)
       write(*,*) 'sum=',V(10)
       write(*,*) 'sum/toch=',VnevMY(numame+1)/numame/Nset

       if (numSim-jSim) 201, 201, 200
201    CLOSE ( UNIT=2)
       END

**********************************************************************
c       SUBROUTINE promOUT(NTOCH,spec1,spec2)
c       IMPLICIT DOUBLE PRECISION (A-H),DOUBLE PRECISION (O-Z)
c       dimension spec1(*),spec2(*)
c       CHARACTER*12 AME   
C
c      write(*,*) ' INPUT FILENAME FOR promout '
c      read(*,15) ame
c 15   format(A12)
c        OPEN ( UNIT=1,FILE=ame)
c        DO 10 I=1,NTOCH
c        WRITE(1,*)SPEC1(I),SPEC2(I)
c 5     FORMAT (1X,4(G14.8,1X))
c   10    CONTINUE
c       CLOSE (UNIT=1)
c      return
c      end 
c###############################################################

c       **********************************************************************


 
