C for ODF3_1 10/04/2012

      SUBROUTINE PrepRak(key,par)
c  Simulation of spectrum   
          IMPLICIT DOUBLE PRECISION (A-H),DOUBLE PRECISION (O-Z)

       include 'NumParam.inc'
       include 'DIMpar.inc'

      common/promsig/ promsigxG(MAXNUCL+1,MAXTRAN),
     * promsigyG(MAXNUCL+1,MAXTRAN),promsigzG(MAXNUCL+1,MAXTRAN),
     * promsigxL(MAXNUCL+1,MAXTRAN),promsigyL(MAXNUCL+1,MAXTRAN),
     * promsigzL(MAXNUCL+1,MAXTRAN)

       common/old11/nucl1,nucl2,Kshape1,Kshape2,Kfft
       common/value11/ncomp(MAXNUCL),IEQ(MAXNUCL)
       common /mp/smp(MAXTRAN,MAXNUCL),smpstr(MAXTRAN,MAXNUCL)
       common /mp1/numtran
       common/value2/spinm2(MAXNUCL,MAXNUCL),prspin(MAXNUCL,MAXNUCL)
       common /APROM/G2X,G2Y,g2Z,A2X(MAXNUCL),A2Y(MAXNUCL),A2Z(MAXNUCL),
     +  GA2X(MAXNUCL),GA2Y(MAXNUCL),GA2Z(MAXNUCL)
      common/value1/spin(MAXNUCL),spinm(MAXNUCL,MAXNUCL),
     *GN(MAXNUCL),DELF, HSRED,Fscale,EPS,TNET(2),XL(3,2)

       common /Ilabel/Ilabel

       dimension spinsum(MAXNUCL+1,MAXTRAN)



            IF (Kshape1.GE.2) THEN 
      alfxG=DABS(par(4))
      alfyG=DABS(par(5))
      alfzG=DABS(par(6))
      betxG=par(25)
      betyG=par(26)
      betzG=par(27)
      gamxG=DABS(par(28))
      gamyG=DABS(par(29))
      gamzG=DABS(par(30))
c      bet2alfgam(1)=betxG**2-4.0D0*alfxG*gamxG
c      bet2alfgam(2)=betyG**2-4.0D0*alfyG*gamyG
c      bet2alfgam(3)=betzG**2-4.0D0*alfzG*gamzG
      ENDIF
      IF (Kshape2.GE.2) THEN  
      alfxL=DABS(par(10))
      alfyL=DABS(par(11))
      alfzL=DABS(par(12))
      betxL=par(31)
      betyL=par(32)
      betzL=par(33)
      gamxL=DABS(par(34))
      gamyL=DABS(par(35))
      gamzL=DABS(par(36))
c      bet2alfgam(4)=betxL**2-4.0D0*alfxL*gamxL
c      bet2alfgam(5)=betyL**2-4.0D0*alfyL*gamyL
c      bet2alfgam(6)=betzL**2-4.0D0*alfzL*gamzL
      ENDIF


      goto(11,12,12,12) key(9)
 11    continue
c     for      ESRMOD1

      IF (Kshape1.EQ.3) THEN
C preparation for gauss line, different width for different transitions
c according to (3.23) in Rakitin, p.111 
c widths are taken as  alfa+betta*m+gamma*m2, where m is sum of spin initial projections 
c for this transition
          do  j=1,ncomp(1) 
             spinsum(1,j)=0.d0 !keep sum spin projection for transitions
          enddo
              klu1=1
       do 34 numnucl=1,nucl1
          klu=0
          do 33 j=1,ncomp(numnucl) 
            do 33 j1=1,klu1 
            klu=klu+1
            spinsum(numnucl+1,klu)=
     *          spinsum(numnucl,j1)+spinm(numnucl,j)
   33     continue
   34  KLU1=KLU 
      do j=1,klu1
        promsigxG(nucl1+1,j)=G2X*(alfxG+betxG*spinsum(nucl1+1,j)+
     *  gamxG*spinsum(nucl1+1,j)**2)**2
        promsigyG(nucl1+1,j)=G2Y*(alfyG+betyG*spinsum(nucl1+1,j)+
     *  gamyG*spinsum(nucl1+1,j)**2)**2
        promsigzG(nucl1+1,j)=G2Z*(alfzG+betzG*spinsum(nucl1+1,j)+
     *  gamzG*spinsum(nucl1+1,j)**2)**2
      enddo
       ENDIF !Kshape1=3
c
      IF (Kshape2.EQ.3) THEN
C preparation for Lorentz line, different width for different transitions
c according to (3.23) in Rakitin, p.111 
c widths are taken as  alfa+betta*m+gamma*m2, where m is sum of spin initial projections 
c for this transition
          do  j=1,ncomp(1) 
             spinsum(1,j)=0.d0 !keep sum spin projection for transitions
          enddo
              klu1=1
       do 36 numnucl=1,nucl1
          klu=0
          do 35 j=1,ncomp(numnucl) 
            do 35 j1=1,klu1 
            klu=klu+1
            spinsum(numnucl+1,klu)=
     *          spinsum(numnucl,j1)+spinm(numnucl,j)
   35     continue
   36  KLU1=KLU 
      do j=1,klu1
        promsigxL(nucl1+1,j)=G2X*(alfxL+betxL*spinsum(nucl1+1,j)+
     *  gamxL*spinsum(nucl1+1,j)**2)**2
        promsigyL(nucl1+1,j)=G2Y*(alfyL+betyL*spinsum(nucl1+1,j)+
     *  gamyL*spinsum(nucl1+1,j)**2)**2
        promsigzL(nucl1+1,j)=G2Z*(alfzL+betzL*spinsum(nucl1+1,j)+
     *  gamzL*spinsum(nucl1+1,j)**2)**2
      enddo
       ENDIF !Kshape2=3
c
      IF (Kshape1.EQ.2) THEN
C preparation for gauss line, different width for different transitions
c according to (3.23) in Rakitin, p.111 
c widths are taken as alfa+betta*m+gamma*m2 for every nuclleus,
c and are summed up as squares
c
        SQRNucl=SQRT(real(nucl1))
        alfxG=alfxG/SQRNucl
        alfyG=alfyG/SQRNucl
        alfzG=alfzG/SQRNucl
        betxG=betxG/SQRNucl
        betyG=betyG/SQRNucl
        betzG=betzG/SQRNucl
        gamxG=gamxG/SQRNucl
        gamyG=gamyG/SQRNucl
        gamzG=gamzG/SQRNucl
c
          do  j=1,ncomp(1) 
             promsigxG(1,j)=0.d0
             promsigyG(1,j)=0.d0
             promsigzG(1,j)=0.d0
          enddo
              klu1=1
       do 32 numnucl=1,nucl1
          klu=0
          do 31 j=1,ncomp(numnucl) 
      sigxG=alfxG+betxG*spinm(numnucl,j)+gamxG*spinm2(numnucl,j)
      sigyG=alfyG+betyG*spinm(numnucl,j)+gamyG*spinm2(numnucl,j)
      sigzG=alfzG+betzG*spinm(numnucl,j)+gamzG*spinm2(numnucl,j)
            do 31 j1=1,klu1 
            klu=klu+1
            promsigxG(numnucl+1,klu)=
     *          promsigxG(numnucl,j1)+sigxG**2
            promsigyG(numnucl+1,klu)=
     *          promsigyG(numnucl,j1)+sigyG**2
            promsigzG(numnucl+1,klu)=
     *          promsigzG(numnucl,j1)+sigzG**2
   31     continue
   32  KLU1=KLU 
      do j=1,klu1
        promsigxG(nucl1+1,j)=promsigxG(nucl1+1,j)*G2X
        promsigyG(nucl1+1,j)=promsigyG(nucl1+1,j)*G2Y
        promsigzG(nucl1+1,j)=promsigzG(nucl1+1,j)*G2Z
      enddo
       ENDIF !Kshape1=2
c
      IF (Kshape2.EQ.2) THEN
C preparation for lorench line, different width for different transitions
c according to (3.23) in Rakitin, p.111, width - similar gauss shape 
c
        SQRNucl=SQRT(real(nucl1))
        alfxL=alfxL/SQRNucl
        alfyL=alfyL/SQRNucl
        alfzL=alfzL/SQRNucl
        betxL=betxL/SQRNucl
        betyL=betyL/SQRNucl
        betzL=betzL/SQRNucl
        gamxL=gamxL/SQRNucl
        gamyL=gamyL/SQRNucl
        gamzL=gamzL/SQRNucl
c
          do  j=1,ncomp(1) 
             promsigxL(1,j)=0.d0
             promsigyL(1,j)=0.d0
             promsigzL(1,j)=0.d0
          enddo
              klu1=1
       do 42 numnucl=1,nucl1
          klu=0
          do 41 j=1,ncomp(numnucl) 
      sigxL=alfxL+betxL*spinm(numnucl,j)+gamxL*spinm2(numnucl,j)
      sigyL=alfyL+betyL*spinm(numnucl,j)+gamyL*spinm2(numnucl,j)
      sigzL=alfzL+betzL*spinm(numnucl,j)+gamzL*spinm2(numnucl,j)
            do 41 j1=1,klu1 
            klu=klu+1
            promsigxL(numnucl+1,klu)=
     *          promsigxL(numnucl,j1)+sigxL**2
            promsigyL(numnucl+1,klu)=
     *          promsigyL(numnucl,j1)+sigyL**2
            promsigzL(numnucl+1,klu)=
     *          promsigzL(numnucl,j1)+sigzL**2
   41     continue
   42  KLU1=KLU 
      do j=1,klu1
        promsigxL(nucl1+1,j)=promsigxL(nucl1+1,j)*G2X
        promsigyL(nucl1+1,j)=promsigyL(nucl1+1,j)*G2Y
        promsigzL(nucl1+1,j)=promsigzL(nucl1+1,j)*G2Z
      enddo
      END IF  !Kshape2=2
c
      GOTO 100
 12       continue
c      for  ESRMOD2
      IF (Kshape1.EQ.3) THEN
C preparation for gauss line, different width for different transitions
c according to (3.23) in Rakitin, p.111
c widths are taken as half sum of alfa+betta*m+gamma*m2 for initial state and
c alfa-betta*m+gamma*m2 for final state, where m is sum of smp for initial state
c and smpstr for final state
            do 53 itran=1,numtran
            smpsum= 0.d0
            smpstrsum= 0.d0
                  do in=1,nucl1
            smpsum= smpsum+smp(itran,in)
            smpstrsum= smpstrsum+smpstr(itran,in)
                  end do 
      sigxG=(alfxG-betxG*smpsum+gamxG*smpsum**2+
     *      alfxG+betxG*smpstrsum+gamxG*smpstrsum**2)/2.d0
      sigyG=(alfyG-betyG*smpsum+gamyG*smpsum**2+
     *      alfyG+betyG*smpstrsum+gamyG*smpstrsum**2)/2.d0
      sigzG=(alfzG-betzG*smpsum+gamzG*smpsum**2+
     *      alfzG+betzG*smpstrsum+gamzG*smpstrsum**2)/2.d0

            promsigxG(1,itran)= G2X*sigxG**2
            promsigyG(1,itran)= G2Y*sigyG**2
            promsigzG(1,itran)= G2Z*sigzG**2
 53         continue
      ENDIF !Kshape1=3
c
      IF (Kshape2.EQ.3) THEN
C preparation for lorentz line by similar way
            do 62 itran=1,numtran
            smpsum= 0.d0
            smpstrsum= 0.d0
                  do in=1,nucl1
            smpsum= smpsum+smp(itran,in)
            smpstrsum= smpstrsum+smpstr(itran,in)
                  end do 
      sigxL=(alfxL-betxL*smpsum+gamxL*smpsum**2+
     *      alfxL+betxL*smpstrsum+gamxL*smpstrsum**2)/2.d0
      sigyL=(alfyL-betyL*smpsum+gamyL*smpsum**2+
     *      alfyL+betyL*smpstrsum+gamyL*smpstrsum**2)/2.d0
      sigzL=(alfzL-betzL*smpsum+gamzL*smpsum**2+
     *      alfzL+betzL*smpstrsum+gamzL*smpstrsum**2)/2.d0

            promsigxL(1,itran)= G2X*sigxL**2
            promsigyL(1,itran)= G2Y*sigyL**2
            promsigzL(1,itran)= G2Z*sigzL**2
 62         continue
      ENDIF !Kshape2=3

c
      IF (Kshape1.EQ.2) THEN
C preparation for gauss line, different width for different transitions
c according to (3.23) in Rakitin, p.111
c widths are taken as half sum of alfa+betta*m+gamma*m2 for initial state and
c  alfa-betta*m+gamma*m2 for final state for every nuclleus, and are summed up as squares
c
        SQRNucl=SQRT(real(nucl1))
        alfxG=alfxG/SQRNucl
        alfyG=alfyG/SQRNucl
        alfzG=alfzG/SQRNucl
        betxG=betxG/SQRNucl
        betyG=betyG/SQRNucl
        betzG=betzG/SQRNucl
        gamxG=gamxG/SQRNucl
        gamyG=gamyG/SQRNucl
        gamzG=gamzG/SQRNucl
c
            do 51 itran=1,numtran
            promsigxG(1,itran)= 0.d0
            promsigyG(1,itran)= 0.d0
            promsigzG(1,itran)= 0.d0
                  do in=1,nucl1
      sigxG=(alfxG-betxG*smp(itran,in)+gamxG*smp(itran,in)**2+
     *      alfxG+betxG*smpstr(itran,in)+gamxG*smpstr(itran,in)**2)/2.d0
      sigyG=(alfyG-betyG*smp(itran,in)+gamyG*smp(itran,in)**2+
     *      alfyG+betyG*smpstr(itran,in)+gamyG*smpstr(itran,in)**2)/2.d0
      sigzG=(alfzG-betzG*smp(itran,in)+gamzG*smp(itran,in)**2+
     *      alfzG+betzG*smpstr(itran,in)+gamzG*smpstr(itran,in)**2)/2.d0
            promsigxG(1,itran)= promsigxG(1,itran)+sigxG**2
            promsigyG(1,itran)= promsigyG(1,itran)+sigyG**2
            promsigzG(1,itran)= promsigzG(1,itran)+sigzG**2
                  end do 
            promsigxG(1,itran)= promsigxG(1,itran)*G2X
            promsigyG(1,itran)= promsigyG(1,itran)*G2Y
            promsigzG(1,itran)= promsigzG(1,itran)*G2Z
 51         continue
      ENDIF !Kshape1=2
c
      IF (Kshape2.EQ.2) THEN
C preparation for lorentz line by similar way
        SQRNucl=SQRT(real(nucl1))
        alfxL=alfxL/SQRNucl
        alfyL=alfyL/SQRNucl
        alfzL=alfzL/SQRNucl
        betxL=betxL/SQRNucl
        betyL=betyL/SQRNucl
        betzL=betzL/SQRNucl
        gamxL=gamxL/SQRNucl
        gamyL=gamyL/SQRNucl
        gamzL=gamzL/SQRNucl
c
            do 61 itran=1,numtran
            promsigxL(1,itran)= 0.d0
            promsigyL(1,itran)= 0.d0
            promsigzL(1,itran)= 0.d0
                  do in=1,nucl1
      sigxL=(alfxL-betxL*smp(itran,in)+gamxL*smp(itran,in)**2+
     *      alfxL+betxL*smpstr(itran,in)+gamxL*smpstr(itran,in)**2)/2.d0
      sigyL=(alfyL-betyL*smp(itran,in)+gamyL*smp(itran,in)**2+
     *      alfyL+betyL*smpstr(itran,in)+gamyL*smpstr(itran,in)**2)/2.d0
      sigzL=(alfzL-betzL*smp(itran,in)+gamzL*smp(itran,in)**2+
     *      alfzL+betzL*smpstr(itran,in)+gamzL*smpstr(itran,in)**2)/2.d0
            promsigxL(1,itran)= promsigxL(1,itran)+sigxL**2
            promsigyL(1,itran)= promsigyL(1,itran)+sigyL**2
            promsigzL(1,itran)= promsigzL(1,itran)+sigzL**2
                  end do 
            promsigxL(1,itran)= promsigxL(1,itran)*G2X
            promsigyL(1,itran)= promsigyL(1,itran)*G2Y
            promsigzL(1,itran)= promsigzL(1,itran)*G2Z
 61         continue
      ENDIF !Kshape2=2
c
  100     CONTINUE 

       IF ((Kfft.EQ.2).and.(Kshape2.GE.1)) THEN 
c FFT calculation      for convolution
        Ilabel=202
       ELSE
         IF (Kshape1.GE.1) THEN
           IF (Kshape2.GE.1) THEN
c     convolution gauss/lorentz
             Ilabel=301
           ELSE
C forma linii gauss
        Ilabel=101
           ENDIF
C forma linii-lorench
         ELSE 
          Ilabel=201
         END IF
       ENDIF
       RETURN
       END
