C for ODF3_1 10/04/2012

      SUBROUTINE SPHERGARM (z,f,w,sph0,sph1,sph2)
c      w must be even
c      SUBROUTINE SPHERGARM calculates only even spheric harmonica
      IMPLICIT DOUBLE PRECISION (A-H),DOUBLE PRECISION (O-Z)
       include 'NumParam.inc'

      INTEGER w
      DIMENSION sph0(NumJ),sph1(NumJ,NumLK),sph2(NumJ,NumLK)
       parameter (PI=3.1415926535897932384626433832795D0)
            
      do i=0,w,2      
      ind=i/2
      sph0(ind+1)=plgndr(i,0,z)
      end do 

      do i=2,w,2      
      ind=i/2
        do j=1,i
        plg=plgndr(i,j,z)         
        sph1(ind,j)=plg*dcos(j*f)
        sph2(ind,j)=plg*dsin(j*f)                
         end do
      end do 
      RETURN 
      END


c********************************************************************
